#ifndef _GC_H
#define _GC_H

template <class T>
class GC
{
public:
	static void Collect()
	{
		T::SPAllocator::SPIterator i;

		for (i = T::SPAllocator::iterator(); i; ++i)
		{
			T* p = i();
			p->setActiveFlag(p->active());
		}
		for (i = T::SPAllocator::iterator(); i; ++i)
		{
			T* p = i();
			if (p->getActiveFlag())
				MarkActive(p);
		}
		for (i = T::SPAllocator::iterator(); i; ++i)
		{
			T* p = i();
			if (!p->getActiveFlag())
				delete p;
		}
		T::ObjectAllocator::Compact();
	}
private:
	static void MarkActive(T* p)
	{
		Iterator<T>* i;
		for (i = static_cast<const GCObject<T>*>(p->getObject())->iterator(); 
			     (*i); ++i)
		{
			T* p2 = const_cast<T*>((*i)());
			if (!p2->getActiveFlag())
			{
				p2->setActiveFlag(true);
				MarkActive(p2);
			}
		}
		delete i;
	}
};
#endif // _GC_H