#include "sp.h"
#include "gc.h"
#include "policy.h"
#include <iostream>

typedef AbstractSP<	UnsafeRefCounter<unsigned int>, 
					PoolProxy<1000>::PoolAllocation, 
					GC,
					MarkSweepObjectAllocator> asp_t;

template <class T>
class A : public GCObject<T>
{
public:
	class AIterator : public Iterator<T>
	{
	public:
		virtual void operator++(){}
		virtual const T* operator()(){return 0;}
		virtual operator const void*() const {return 0;}
	};

	virtual Iterator<T>* iterator() const {return new AIterator;}

	A()
	{
		std::cout << "A ctor" << std::endl;
	}

	~A()
	{
		std::cout << "A dtor" << std::endl;
	}
	int x;
};

template <class T>
class C : public A<T>
{
public:
	C()
	{
		std::cout << "C ctor" << std::endl;
	}

	~C()
	{
		std::cout << "C dtor" << std::endl;
	}
};

template <class T>
class B : public GCObject<T>
{
public:
	class MyClassIterator : public Iterator<T>
	{
	public:
		MyClassIterator(const B<T>* b) : d_b(b), d_flag(true) {}
		virtual void operator++(){d_flag = false;}
		virtual const T* operator()()
		{
			return d_b->c.GetSP();
		}
		virtual operator const void*() const {return d_flag ? &d_flag : 0;}
	private:
		const B* d_b;
		bool d_flag;
	};

	virtual Iterator<T>* iterator() const {return new MyClassIterator(this);}

	B()
	{
		std::cout << "B ctor" << std::endl;
	}

	~B()
	{
		std::cout << "B dtor" << std::endl;
	}
	int y;
	WH<C<asp_t>, UnsafeRefCounter<unsigned int>, PoolProxy<1000>::PoolAllocation, GC, MarkSweepObjectAllocator > c;
};

typedef SH<A<asp_t>, UnsafeRefCounter<unsigned int>, PoolProxy<1000>::PoolAllocation, GC, MarkSweepObjectAllocator> SHA;
typedef SH<B<asp_t>, UnsafeRefCounter<unsigned int>, PoolProxy<1000>::PoolAllocation, GC, MarkSweepObjectAllocator> SHB;
typedef SH<C<asp_t>, UnsafeRefCounter<unsigned int>, PoolProxy<1000>::PoolAllocation, GC, MarkSweepObjectAllocator> SHC;

void f(SHA a)
{
	std::cout << a->x << std::endl;
}

int main()
{
	{
		SHC c;
		c->x = 100;
		SHA a;
		SHB b;
		b->c = c;
		a = b->c;
		f(b->c);
	}
	GC<asp_t>::Collect();

const int ci = 5;
int i;
i = const_cast<int>(ci);



	return 0;
}